/* $Id: btree.h,v 1.1.1.1 2004/11/13 23:28:02 advanced Exp $

   B*Tree Implement
   2004.10.28
   Hyunsik Choi(advanced@users.kldp.net) 
   http://acdbt.org/wiki/wiki.php/tinySQL/B%2ATrees */

#ifndef TINYSQL_BTREE_H
#define TINYSQL_BTREE_H 1

#include<btree/io.h>
#include<type.h>
#include<utils.h>

#define MULTI 5 
#define SZ_KEY 8

typedef char Key[SZ_KEY];
typedef offset Node;

#pragma pack(1)
typedef struct BTreeNode_ {
	uint8 count;
	Key key[MULTI];
	uint32 idx[MULTI];
	Node child[MULTI];
} BTreeNode;
#pragma pack(

typedef struct BTree_ {
	IO *io;
	BTreeNode *root;
	uint32 count;
} BTree;


int bst_creat(const char *filename);
BTree* bst_open(const char *filename);
int bst_insert_node(BTree *tree,Key key,uint32 idx);
BTreeNode* bst_search_node(BTree *tree,Key key);

#define bst_is_empty(tree) ((tree)->count == 0 ? 1:0)
#endif
