// $Id: sqlparser.y,v 1.1.1.1 2004/11/13 23:28:02 advanced Exp $
// Reference - http://acdbt.org/wiki/wiki.php?tinySQL/SQL

%{
#include<stdio.h>
#define YYSTYPE int
void yyerror(char *str);
extern char *yytext;
%}

// SQL92 reserved keyword
%token ABSOLUTE  ACTION  ADD  ALL
%token ALLOCATE  ALTER  AND
%token ANY  ARE
%token AS  ASC
%token ASSERTION  AT
%token AUTHORIZATION  AVG
%token BEGIN_  BETWEEN  BIT  BIT_LENGTH
%token BOTH  BY
%token CASCADE  CASCADED  CASE  CAST
%token CATALOG
%token CHAR  CHARACTER  CHAR_LENGTH
%token CHARACTER_LENGTH  CHECK  CLOSE  COALESCE
%token COLLATE  COLLATION
%token COLUMN  COMMIT
%token CONNECT
%token CONNECTION  CONSTRAINT
%token CONSTRAINTS  CONTINUE
%token CONVERT  CORRESPONDING  COUNT  CREATE  CROSS
%token CURRENT
%token CURRENT_DATE  CURRENT_TIME
%token CURRENT_TIMESTAMP  CURRENT_USER  CURSOR
%token DATE  DAY  DEALLOCATE  DEC
%token DECIMAL  DECLARE  DEFAULT  DEFERRABLE
%token DEFERRED  DELETE  DESC  DESCRIBE  DESCRIPTOR
%token DIAGNOSTICS
%token DISCONNECT  DISTINCT  DOMAIN  DOUBLE  DROP
%token ELSE  END  END_EXEC  ESCAPE
%token EXCEPT  EXCEPTION
%token EXEC  EXECUTE  EXISTS
%token EXTERNAL  EXTRACT
%token FALSE  FETCH  FIRST  FLOAT  FOR
%token FOREIGN  FOUND  FROM  FULL
%token GET  GLOBAL  GO  GOTO
%token GRANT  GROUP
%token HAVING  HOUR
%token IDENTITY  IMMEDIATE  IN  INDICATOR
%token INITIALLY  INNER  INPUT
%token INSENSITIVE  INSERT  INT  INTEGER  INTERSECT
%token INTERVAL  INTO  IS
%token ISOLATION
%token JOIN
%token KEY
%token LANGUAGE  LAST  LEADING  LEFT
%token LEVEL  LIKE  LOCAL  LOWER
%token MATCH  MAX  MIN  MINUTE  MODULE
%token MONTH
%token NAMES  NATIONAL  NATURAL  NCHAR  NEXT  NO
%token NOT  NULL_SPECIFICATION
%token NULLIF  NUMERIC
%token OCTET_LENGTH  OF
%token ON  ONLY  OPEN  OPTION  OR
%token ORDER  OUTER
%token OUTPUT  OVERLAPS
%token PAD  PARTIAL  POSITION  PRECISION  PREPARE
%token PRESERVE  PRIMARY
%token PRIOR  PRIVILEGES  PROCEDURE  PUBLIC
%token READ  REAL  REFERENCES  RELATIVE  RESTRICT
%token REVOKE  RIGHT
%token ROLLBACK  ROWS
%token SCHEMA  SCROLL  SECOND  SECTION
%token SELECT
%token SESSION  SESSION_USER  SET
%token SIZE  SMALLINT  SOME  SPACE  SQL  SQLCODE
%token SQLERROR  SQLSTATE
%token SUBSTRING  SUM  SYSTEM_USER
%token TABLE  TEMPORARY
%token THEN  TIME  TIMESTAMP
%token TIMEZONE_HOUR  TIMEZONE_MINUTE
%token TO  TRAILING  TRANSACTION
%token TRANSLATE  TRANSLATION  TRIM  TRUE
%token UNION  UNIQUE  UNKNOWN  UPDATE  UPPER  USAGE
%token USER  USING
%token VALUE  VALUES  VARCHAR  VARYING  VIEW
%token WHEN  WHENEVER  WHERE  WITH  WORK  WRITE
%token YEAR
%token ZONE

// internal token
%token ASTERISK
%token CHAR_SET_NAME CHARACTER_STRING_LITERAL COMMA
%token CONCATENATION_OPERATOR
%token EQUALS_OPERATOR
%token DELIMITED_IDENTIFIER DIGIT
%token GREATER_THAN_OPERATOR GREATER_THAN_OR_EQUALS_OPERATOR
%token LEFT_PAREN LESS_THAN_OPERATOR LESS_THAN_OR_EQUALS_OPERATOR
%token MINUS_SIGN
%token NOT_EQUALS_OPERATOR
%token PERIOD PLUS_SIGN
%token RIGHT_PAREN
%token UNDERSCORE
%token QUOTE QUOTE_SYMBOL
%token SEMICLON SOLIDUS

// define
%start direct_SQL_statement
%%

direct_SQL_statement :
	directly_SQL_executable_statement SEMICLON {printf("sql ok\n");}
	;

directly_SQL_executable_statement :
	direct_SQL_data_statement |
	SQL_schema_statement |
	SQL_transaction_statement ;
	
direct_SQL_data_statement :
	delete_statement_searched |
	direct_select_statement_multiple_rows |
	insert_statement |
	update_statement_searched ;

SQL_schema_statement : // request to improve
	SQL_schema_definition_statement ;
//	SQL_schema_manipulation_statement ;

SQL_schema_definition_statement : //request improve
//	schema_defintion |
	table_definition ;
/*	view_definition |
	grant_statement |
	domain_definition |
	character_set_definition |
	collation_definition |
	translation_definition |
	assertion_definition*/

table_definition : // request improve
	CREATE TABLE table_name table_element_list ;	

table_element_list :
	LEFT_PAREN table_element_list_factor RIGHT_PAREN;

table_element_list_factor :
	table_element |
	table_element_list_factor COMMA table_element;

table_element :
	column_definition ;
//	table_constraint_definition ;

column_definition : //request to improve
	column_name data_type;

data_type : //request to improve
	character_string_type |
//	national_character_string_type |
//	bit_string_type |
	numeric_type ;
/*	datetime_type |
	interval_type ;*/

character_string_type :
	CHARACTER |
	CHARACTER LEFT_PAREN DIGIT RIGHT_PAREN |
	CHAR |
	CHAR LEFT_PAREN DIGIT RIGHT_PAREN |
	CHARACTER VARYING LEFT_PAREN DIGIT RIGHT_PAREN |
	CHAR VARYING LEFT_PAREN DIGIT RIGHT_PAREN |
	VARCHAR LEFT_PAREN DIGIT RIGHT_PAREN;

numeric_type :
	NUMERIC |
	NUMERIC LEFT_PAREN DIGIT RIGHT_PAREN |
	DECIMAL |
	DECIMAL LEFT_PAREN DIGIT RIGHT_PAREN |
	DEC |
	DEC LEFT_PAREN DIGIT RIGHT_PAREN
	INTEGER |
	INT |
	SMALLINT ;

/*length :
	DIGIT;*/

SQL_transaction_statement :
	commit_statement |
	rollback_statement ;

commit_statement :
	COMMIT ;

rollback_statement :
	ROLLBACK ;

delete_statement_searched :
	DELETE FROM table_name |
	DELETE FROM table_name WHERE search_condition;

direct_select_statement_multiple_rows : //request to improve
	query_expression ;
//	query_expression order_by_clause;

query_expression : //request improve
	non_join_query_expression ;
//	joind table ;

non_join_query_expression: // request to improve
	non_join_query_term ;
/*	query_expression UNION query_term |
	query_expression UNION ALL query_term |
	query_expression UNION corresponding_spec query_term |
	query_expression UNION ALL corresponding_spec query_term |
	query_expression EXCEPT query_term |
	query_expression EXCEPT ALL query_term |
	query_expression EXCEPT corresponding_spec query_term |
	query_expression EXCEPT ALL corresponding_spec query_term ;*/
	
non_join_query_term : //request to improve
	non_join_query_primary ;
/*	query_term INTERSECT query_primary ;
	query_term INTERSECT ALL query primary |
	query_term INTERESCT corresponding_spec query_primary |
	query_term INTERSECT ALL corresponding_spec query_primary ;*/

non_join_query_primary : //request to improve
	simple_table ;
//	LEFT_PAREN non_join_query_expression RIGHT_PAREN ;

simple_table :
	query_specification ;
/*	table_value_constructor |
	explicit_table ;*/

query_specification :
	SELECT select_list table_expression ;
//	SELECT set_quantifier select_list table_expression ;

select_list :
	ASTERISK |
	select_sublist_list;

select_sublist_list :
	select_sublist |
	select_sublist_list COMMA select_sublist ;

select_sublist : //request to improve
	derived_column |
	identifier PERIOD ASTERISK;

derived_column : // request to improve
	value_expression |
	value_expression as_clause;

as_clause :
	column_name |
	AS column_name;

table_expression :
	from_clause |
	from_clause where_clause ;
/*	from_clause_factor group_by_clause |
	from_clause_factor group_by_clause having_clause;*/

from_clause :
	FROM table_reference_list;

where_clause :
	WHERE search_condition;

table_reference_list :
	table_reference |
	table_reference_list COMMA table_reference;

table_reference : // request to improve
	table_name |
	table_name AS identifier ;
//	LEFT_PAREN derived_column_list RIGHT_PAREN;*/

insert_statement :
	INSERT INTO ;

update_statement_searched :
	UPDATE table_name SET set_clause_list |
	UPDATE table_name SET set_clause_list WHERE search_condition;

table_name : // request improve
	identifier ;
//	qualified_local_table_name ;

set_clause_list :
	set_clause |
	set_clause_list COMMA set_clause;

set_clause :
	column_name comp_op update_source;

update_source :
	value_expression |
	NULL_SPECIFICATION |
	DEFAULT;

/*not use yet
schema_name :
	identifier ;*/

identifier : 
	CHAR_SET_NAME |
	DELIMITED_IDENTIFIER ;

//today
search_condition :
	boolean_term |
	search_condition OR boolean_term ;

boolean_term :
	boolean_factor |
	boolean_term AND boolean_factor ;

boolean_factor :
	NOT boolean_test |
	boolean_test ;

boolean_test :
	boolean_primary |
	boolean_primary IS truth_value |
	boolean_primary IS NOT truth_value ;

truth_value :
	TRUE |
	FALSE |
	UNKNOWN ;
	
boolean_primary :
	predicate |
	LEFT_PAREN search_condition RIGHT_PAREN ;	

predicate : // request improve
	comparison_predicate |
	between_predicate |
//	in_predicate ;
	null_predicate ;
//	quantified_comparison_predicate ;
/*	exists_predicate ;
	unique_predicate |
	match_predicate |
	overlaps_predicate ;*/

comparison_predicate :
	row_value_constructor comp_op row_value_constructor ;

between_predicate :
	row_value_constructor BETWEEN row_value_constructor AND row_value_constructor |
	row_value_constructor NOT BETWEEN row_value_constructor AND row_value_constructor ;

//in_predicate : ;

null_predicate :
	row_value_constructor IS NULL_SPECIFICATION |
	row_value_constructor IS NOT NULL_SPECIFICATION;

//quantified_comparison_predicate :;
//exists_predicate :;
//unique_predicate :;
//match_predicate :;
//overlaps_predicate :;

row_value_constructor : //request improve
	row_value_constructor_element ;
/*	LEFT_PAREN row_value_constructor_list RIGHT_PAREN |
	row_subquery ;*/

row_value_constructor_element :
	value_expression |
	NULL_SPECIFICATION |
	DEFAULT ;

// row_value_constructor_list : ;
// row_subquery : ;

value_expression :
	numeric_value_expression ;
//	string_value_expression 
//	datetime_value_expression 
//	interval_value_expression ;*/

numeric_value_expression : 
	term |
	numeric_value_expression PLUS_SIGN term |
	numeric_value_expression MINUS_SIGN term ;

term :
	factor |
	term ASTERISK factor |
	term SOLIDUS factor ;

factor :
	sign numeric_primary |
	numeric_primary;

numeric_primary :
	value_expression_primary;

value_expression_primary : //request improve
	unsigned_value_specification |
	column_reference |
	LEFT_PAREN value_expression RIGHT_PAREN;
	
unsigned_value_specification : 
	unsigned_numeric_literal |
	general_literal ;

column_reference : //request to improve
	column_name |
	identifier PERIOD column_name;

column_name :
	identifier;

unsigned_numeric_literal :
	exact_numeric_literal |
	approximate_numeric_literal ;	

exact_numeric_literal : 
	DIGIT PERIOD DIGIT |
	PERIOD DIGIT |
	DIGIT;
approximate_numeric_literal : 
	exact_numeric_literal 'E' DIGIT |
	exact_numeric_literal 'e' DIGIT |
	exact_numeric_literal 'E' sign DIGIT |
	exact_numeric_literal 'e' sign DIGIT ;

sign :
	PLUS_SIGN |
	MINUS_SIGN ;

general_literal : // request improve
	CHARACTER_STRING_LITERAL ; // fix me(it can't process to quote symbol)

comp_op :
	EQUALS_OPERATOR |
	NOT_EQUALS_OPERATOR |
	LESS_THAN_OPERATOR |
	GREATER_THAN_OPERATOR |
	LESS_THAN_OR_EQUALS_OPERATOR |
	GREATER_THAN_OR_EQUALS_OPERATOR;
%%

void yyerror(char *str)
{
	fprintf(stderr,"Error: %s at %s\n",str,yytext);
}

int main(int argc,char *argv[])
{
	return yyparse();
}
