/* $Id: sqlscanner.l,v 1.1.1.1 2004/11/13 23:28:02 advanced Exp $ */

%{
#include"sqlparser.h"
%}

%%
[ \t]+ ;
\n ;

"=" return EQUALS_OPERATOR;
"<>" return NOT_EQUALS_OPERATOR;
"<" return LESS_THAN_OPERATOR;
">" return GREATER_THAN_OPERATOR;
"<=" return LESS_THAN_OR_EQUALS_OPERATOR;
">=" return GREATER_THAN_OR_EQUALS_OPERATOR;

"+" return PLUS_SIGN;
"-" return MINUS_SIGN;
"*" return ASTERISK;
"/" return SOLIDUS;

"||" return CONCATENATION_OPERATOR;

"(" return LEFT_PAREN;
")" return RIGHT_PAREN;

";" return SEMICLON;
"''" return QUOTE_SYMBOL;
"'" return QUOTE;
"." return PERIOD;
, return COMMA;

AS return AS;
AND return AND;
BETWEEN return BETWEEN;

CREATE return CREATE;
CHAR return CHAR;
CHARACTER return CHARACTER;
'[^'\n]*' return CHARACTER_STRING_LITERAL;
COMMIT return COMMIT;
COLLATE return COLLATE;


DELETE return DELETE;
DEC return DEC;
DECIMAL return DECIMAL;
[0-9]+ return DIGIT;


FROM return FROM;

INSERT return INSERT;
INT return INT;
INTEGER return INTEGER;
INTO return INTO;

NOT return NOT;
NULL return NULL_SPECIFICATION;
NUMERIC return NUMERIC;

OR return OR;
ROLLBACK return ROLLBACK;

SELECT return SELECT;
SET return SET;
SMALLINT return SMALLINT;

TABLE return TABLE;

UPDATE return UPDATE;
VARCHAR return VARCHAR;
VARYING return VARYING;
WHERE return WHERE;

[a-z][a-zA-Z0-9_]+ { return CHAR_SET_NAME;}
\"[^"\n]*\" return DELIMITED_IDENTIFIER;
. return yytext[0];
%%
int yywrap()
{
	return 1;
}
