// $Id: record1.c,v 1.2 2005/02/28 05:30:48 advanced Exp $

// Test : Jungyull Lim (alstlove@acdbt.org)

// spiking code for record process $Id

#include<sys/types.h>
#include<sys/stat.h>
#include<fcntl.h>
#include<unistd.h>
#include<string.h>
#include<stdio.h>

#include<utils.h>

int file;

typedef struct People_
{
    int id;
    char name[12];
    int age;
    char addr[64];
} People;

off_t seek_by_id(int id)
{
    int result;
    off_t offset = 0;
    People tmp;
    
    lseek(file,0,SEEK_SET);

    while(result>0)
    {
	offset = lseek(file,0,SEEK_CUR);
	result = read(file,(void*)&tmp,sizeof(People));

	if(tmp.id == id)
	{
	    return offset;
	}
    }

    return -1;
}   

int insert(People *data)
{
    int result = 0;
    
    lseek(file,0,SEEK_END);
    result = write(file,data,sizeof(People));

    return result;
}


int extract(int id,People **data)
{
    off_t offset;
    People *people;
    int result = 0;

    people = (People*)u_malloc(sizeof(People));
    
    offset = seek_by_id(id);
    lseek(file,offset,SEEK_SET);

    result = read (file,people,sizeof(People));

    *data = people;

    if(result>0)
	return 0;
    else return -1;
}

void insert_process()
{
    People data;
   
    memset(&data,0,sizeof(People));

    printf("id : ");
    scanf("%d",&data.id);
    printf("name : ");
    scanf("%s",&data.name);
    printf("age : ");
    scanf("%d",&data.age);
    printf("addr : ");
    scanf("%s",&data.addr);

    printf("%d\n",insert(&data));
}


void extract_process()
{
    int id;
    People *data;

    
    printf("input id for scan\n");
    scanf("%d",&id);

    extract(id,(People**)&data);
 
    printf("id: %d\n name: %s\n age: %d\n addr: %s\n",
	    data->id,data->name,data->age,data->addr);
}


int main(int argc,char *argv[])
{
    int menu=0;

    file = open("./record1.dat",O_CREAT|O_RDWR,0644);
    
    while(1)
    {
	printf("1. insert\n");
	printf("2. extract\n");
	scanf("%d",&menu);

	switch(menu)
	{
	    case 1: insert_process();break;
	    case 2: extract_process();break;
	    default : return 0;
	}
    }
}
