#include<sys/types.h>
#include<sys/stat.h>
#include<fcntl.h>

#include<schema.h>

int fd;

char *Type[] = {
	"Char",
	"Varchar",
	"Int",
	"Smalint",
	"Numeric",
	"Real",
	"Double",
	"Float",
	"Date",
	"Time",
	"Timestamp"
};

int open_dic_file(void)
{
	int result = 0;

	fd = open("./schema.dic",O_RDONLY);

	if(fd<0)
		return -1;

	return 0;
}


int main(int argc,char *argv[])
{
	Table *table;
	Attribute *attr;

	int i;
	
	if(open_dic_file() < 0)
		abort();

	table = TableAlloc();
	

	read(fd,(void*)table,sizeof(Table));

	printf( "Table name: %s\n"
			"Table id: %d\n"
			"count of field: %d\n"
			,table->t_name
			,table->t_id
			,table->t_nattr
	);

	
	attr = (Attribute*)u_malloc(sizeof(Attribute)*table->t_nattr);
	read(fd,(void*)attr,sizeof(Attribute)*table->t_nattr);
	
	for(i=0;i<table->t_nattr;i++)
	{
		printf( "%d  %s  %s  %d\n",
				attr[i].a_id,
				attr[i].a_name,
				Type[attr[i].a_type],
				attr[i].a_length
		);
	}
						
	return 0;
}
