/* 여러 유틸리티 함수들을 여러 가지문제로 제작했다
	Hyunsik Choi(hyunsik80@daum.net) 2004년 8월 19일
	$Id: utils.c,v 1.2 2005/02/28 05:30:48 advanced Exp $
*/



#include<assert.h>
#include<string.h>
#include<utils.h>

/* malloc 의 에러 처리 부분을 통합한것 */
void* u_malloc(size_t size){
	void *mem;

	mem = malloc(size);
	if(mem == NULL)
		abort();

	return mem;
}

/* 주의 : 이걸로 만든 string 은 free 로 해제하여야 한다
   str1 과 str2 를 붙인 결과를 반환한다 */
char* u_strcat(const char *str1,const char *str2)
{
	char *tmpstr;
	int len_str1=0,len_str2=0;

	len_str1=strlen(str1);
	len_str2=strlen(str2);

	tmpstr = (char*)u_malloc(len_str1+len_str2+1);

	strncpy(tmpstr,str1,len_str1);
	strncat(tmpstr,str2,len_str2);

	return tmpstr;
}

char* u_strdup(const char *str)
{
	char *tmpstr;

	tmpstr = (char*)u_malloc(strlen(str)+1);

	strncpy(tmpstr,str,strlen(str));

	return tmpstr;
}
