// $Id: sqlproc.h,v 1.1.1.1 2005/02/28 05:37:15 advanced Exp $

#ifndef SQLPROC_H
#define SQLPROC_H

#include<vector>

#ifdef DEBUG
void sql_ok(); 
#endif

typedef enum Statement {
	_NONE,
	// schema define stmts
	_SCHEMA, _TABLE, _VIEW, _GRANT, _DOMAIN,
	// schema manipulation stmts
	_DROP_SCHEMA, _ALTER, _DROP_TABLE, _DROP_VIEW,_REVOKE_STMT,
	_ALTER_DOMAIN, _DROP_DOMAIN ,
	// data manipulation stmts
	_DELETE, _SELECT, _INSERT, _UPDATE, _TEMPORARY
} Statement;

typedef struct TableElmt {
	char *tbname;
	int domain;
	unsigned int size;
} TableElmt;

typedef struct DataType {
	int domain;
	int size;
} DataType;

typedef struct Node {
	Node() {

		return;
	}

	~Node() {
		return;
	}

	Statement stmt;
	std::vector<TableElmt*> tables;
} Node;



Node *new_node(Statement stmt);
Node* new_node(Statement stmt,TableElmt *tbelmt);
TableElmt *new_table_elmt(char *tbname,DataType *datatype);
DataType *new_data_type(int domain,int size=0);

#endif
