/* $Id: sqlscanner.ll,v 1.1.1.1 2005/02/28 05:37:15 advanced Exp $ */

%{

#include"sqlparser.h"

%}

%option c++
%%
[ \t]+ ;
\n ;

"=" return EQUALS_OPERATOR;
"<>" return NOT_EQUALS_OPERATOR;
"<" return LESS_THAN_OPERATOR;
">" return GREATER_THAN_OPERATOR;
"<=" return LESS_THAN_OR_EQUALS_OPERATOR;
">=" return GREATER_THAN_OR_EQUALS_OPERATOR;

"+" return PLUS_SIGN;
"-" return MINUS_SIGN;
"*" return ASTERISK;
"/" return SOLIDUS;

"||" return CONCATENATION_OPERATOR;

";" return SEMICLON;
"''" return QUOTE_SYMBOL;
"'" return QUOTE;
"." return PERIOD;
"," return COMMA;

AS return AS;
AND return AND;
BETWEEN return BETWEEN;

CREATE return CREATE;
CHAR return CHAR;
CHARACTER return CHARACTER;
'[^'\n]*' return CHARACTER_STRING_LITERAL;
COMMIT return COMMIT;
COLLATE return COLLATE;


DELETE return DELETE;
DEC return DEC;
DECIMAL return DECIMAL;
[0-9]+ { yylval.ival = atol(YYText()); return DIGIT;}


FROM return FROM;

INSERT return INSERT;
INT return INT;
INTEGER return INTEGER;
INTO return INTO;

NOT return NOT;
NULL return _NULL_;
NUMERIC return NUMERIC;

OR return OR;
ROLLBACK return ROLLBACK;

SELECT return SELECT;
SET return SET;
SMALLINT return SMALLINT;

TABLE return TABLE;

UPDATE return UPDATE;
VARCHAR return VARCHAR;
VARYING return VARYING;
WHERE return WHERE;

[a-zA-Z0-9_]+ { yylval.str = (char*)YYText();return IDENTIFIER; }
\"[^"\n]*\" return DELIMITED_IDENTIFIER;
. return yytext[0];
%%
int yywrap()
{
	return 1;
}
